<template>
    <nav class="navbar" style="z-index: 100;">
      <div class="contendor-navbar">
        <div class="navbar-brand">
          <h2 class="texto-bold">Ufrobook</h2>
        </div>
        <div class="navbar-search mb-3 mt-1 position-relative position-absolute top-50 start-50 translate-middle">
          <input class="bg-input" type="text" placeholder="Buscar en Ufrobook" />
          <button><i class="bi bi-search"></i></button>
        </div>
  
        <div class="navbar-menu contedor-iconos me-5">
          <ul class="me-5">
            <li class="mb-1">
              <a href="#" class="iconos"><i class="bi bi-house-fill" style="color: #e4e6eb;"></i></a>
            </li>
            <li class="mb-1">
              <a href="#" class="iconos"><i class="bi bi-bell-fill" style="color: #e4e6eb;"></i></a>
            </li>
            <li class="mb-1">
              <a href="#" class="iconos"><i class="bi bi-chat-fill" style="color: #e4e6eb;"></i></a>
            </li>
          </ul>
          <div class="navbar-profile mx-5 mb-3 collapse" id="navbarNavDarkDropdown">
            <ul class="navbar-nav">
              <li class="nav-item dropdown">
                <button class="btn dropdown-toggle" data-bs-toggle="dropdown" aria-expanded="false">
                  <img v-if="imagenPerfil" :src="imagenPerfil" id="ProfilePicture" style="object-fit:cover"/>
                  <span style="color: #e4e6eb;" class="mx-2">{{ usuario.nombreUsuario }}</span>
                </button>
                <div class="dropdown-menu">
                  <router-link class="dropdown-item" :to="{ path: '/ajustesCuenta' }">Ajustar Cuenta</router-link>
                  <a class="dropdown-item" href="#" @click="cerrarSesion">Cerrar Sesión</a>
                </div>
              </li>
            </ul>
          </div>
        </div>
      </div>
    </nav>
  </template>
  
  <script>
import axios from 'axios';
import { ref, onMounted } from 'vue';
import { useRouter } from 'vue-router';
import {buscarImagenDePerfilDeUnUsuario} from "../../Services/muro/MuroService.js"

export default {
  setup() {
    const usuario = ref({ nombreUsuario: '' });
    const router = useRouter();
    // Obtener el token de acceso del localStorage
    const accessToken = localStorage.getItem('accessToken');

    // Configurar el encabezado 'Authorization' en las solicitudes
    if (accessToken) {
      axios.defaults.headers.common['Authorization'] = accessToken;
    }

    // Función para cerrar sesión
    const cerrarSesion = () => {
      axios.post('http://localhost:3001/usuarios/cerrar-sesion')
        .then(response => {
          console.log(response.data);
          // Eliminar el token de la memoria local y de los headers
          localStorage.removeItem('accessToken');
          axios.defaults.headers.common['Authorization'] = '';

          // Redirigir a la página de inicio de sesión
          router.push('/login');
        })
        .catch(error => {
          console.error(error);
          router.push('/login');
        });
    };
    
    // Obtener el usuario del endpoint
    const obtenerUsuario = async () => {
      try {
        const response = await axios.get('http://localhost:3001/usuarios/sesion');
        usuario.value = response.data;
      } catch (error) {
        console.error('Error al obtener el usuario:', error);
      }
    };

    // Llamar a la función para obtener el usuario al montar el componente
    onMounted(obtenerUsuario);

    return {
      usuario,
      cerrarSesion
    };
  },
  data(){
    return{
      imagenPerfil:null
    }
  },
  methods:{
    async obtenerFoto(){
      try{
        let usuario= await axios.get('http://localhost:3001/usuarios/sesion');
        usuario=usuario.data;
        this.imagenPerfil= await buscarImagenDePerfilDeUnUsuario(usuario)
        
      }catch(e){
        console.log(e)
      }
    }  
  },
  mounted(){
    this.obtenerFoto()
  }
}
</script>

<style scoped>
.bg-input {
    background-color: #E4E6EB;

}


.navbar {
    background-color: #0b33e6;
}

.texto-bold {
    font-weight: bold;
    color: #e4e6eb;
}

.dropdown-menu {
    background-color: #2148c0;
}

.dropdown-menu a {
    color: #e4e6eb;
    font-weight: bold;
}

.dropdown-menu a:hover {
    background-color: #0b33e6;
}

.contendor-navbar {
    display: flex;
    justify-content: space-between;
    width: 100%;
}

.navbar {
    display: flex;
    align-items: center;
    justify-content: space-between;
    height: 60px;
    background-color: #2148c0;
    border-bottom: 1px solid #242526;
}

.navbar-brand {
    margin-left: 20px;
}

.navbar-brand img {
    height: 40px;
}

.navbar-search {
    display: flex;
    align-items: center;
    width: 40%;
}

.navbar-search input {
    width: 80%;
    height: 36px;
    border-radius: 18px;
    border: none;
    padding-left: 20px;
}

.navbar-search button {
    width: 36px;
    height: 36px;
    border-radius: 18px;
    border: none;
    background-color: #e4e6eb;
}

.navbar-search button i {
    color: #606770;
}

.navbar-menu {
    display: flex;
}

.navbar-menu ul {
    display: flex;
    list-style: none;
}

.navbar-menu ul li {
    margin-right: 20px;
}

.iconos {
    display: block;
    width: 40px;
    height: 40px;
    border-radius: 20px;
}

.navbar-menu ul li a:hover {
    background-color: #0b33e6;
    /* color: #0b33e6; */
}

.navbar-menu ul li a i {
    font-size: 28px;
}

.navbar-profile {
    display: flex;
    align-items: center;
}

.navbar-profile img {
    width: 32px;
    height: 32px;
    border-radius: 16px;
}

.navbar-profile span {
    margin-left: 10px;
    font-weight: bold;
}
</style>
